﻿local G, F, C, L = unpack(select(2,...))
local function TestFunc()
if AddUIDB.quest ==  false  then return end

--任务
ObjectiveTrackerFrame:SetScale(.9)--任务大小

--固定任务缩放框体
local rw = ObjectiveTrackerFrame.HeaderMenu.MinimizeButton
rw:ClearAllPoints()
rw:SetPoint("bottomright", Minimap, "bottomright", 10,-15)
rw:SetScale(1.2)

local vm = ObjectiveTrackerFrame


-- 任务物品放左面 -------------------------------------------------------------------
local function moveQuestObjectiveItems(self)
local a = {self:GetPoint()}
       
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", a[2], "TOPLEFT", -40, 2)
		self:SetScale(1.2)
		self:SetFrameLevel(0)
end
	
local qitime = 0
local qiinterval = 1
	
hooksecurefunc("QuestObjectiveItem_OnUpdate", function(self, elapsed)
   	qitime = qitime + elapsed
	moveQuestObjectiveItems(self)
    qitime = 0
end)


-- 标题样式 -------------------------------------------------------
    if IsAddOnLoaded("Blizzard_ObjectiveTracker") then
        hooksecurefunc("ObjectiveTracker_Update", function(reason, id)
            if vm.MODULES then  
                for i = 1, #vm.MODULES do                               
		            vm.MODULES[i].Header.Background:SetAtlas(nil)
		            vm.MODULES[i].Header.Text:SetFont(STANDARD_TEXT_FONT, 16,"OUTLINE")
		            vm.MODULES[i].Header.Text:ClearAllPoints()
		            vm.MODULES[i].Header.Text:SetPoint("Left", vm.MODULES[i].Header, 60, 0)
		            vm.MODULES[i].Header.Text:SetJustifyH("Left")
	            end
	        end
	    end)
	end
     
--------------------------------------------------------------------------------------------------------
--                                    显示任务等级                                      --
--------------------------------------------------------------------------------------------------------
local QuestLevelPatch = {}

-- 追踪栏显示任务等级
function SetBlockHeader_hook()
	for i = 1, GetNumQuestWatches() do
		local questID, title, questLogIndex, numObjectives, requiredMoney, isComplete, startEvent, isAutoComplete, failureTime, timeElapsed, questType, isTask, isStory, isOnMap, hasLocalPOI = GetQuestWatchInfo(i)
		if ( not questID ) then
			break
		end
		local oldBlock = QUEST_TRACKER_MODULE:GetExistingBlock(questID)
		if oldBlock then
			local oldHeight = QUEST_TRACKER_MODULE:SetStringText(oldBlock.HeaderText, title, nil, OBJECTIVE_TRACKER_COLOR["Header"])
			local newTitle = "["..select(2, GetQuestLogTitle(questLogIndex)).."] "..title
			local newHeight = QUEST_TRACKER_MODULE:SetStringText(oldBlock.HeaderText, newTitle, nil, OBJECTIVE_TRACKER_COLOR["Header"])

		end
	end
end
hooksecurefunc(QUEST_TRACKER_MODULE, "Update", SetBlockHeader_hook)




-- 任务追踪自动开启/关闭 --------------------------------------------
--ObjectiveTracker_Collapse()--任务关闭
    local vmboss = CreateFrame("Frame", nil)
    vmboss:RegisterEvent("PLAYER_ENTERING_WORLD")
    vmboss:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
    vmboss:RegisterEvent("UNIT_TARGETABLE_CHANGED")
    vmboss:RegisterEvent("PLAYER_REGEN_ENABLED")
    --vmboss:RegisterEvent("UPDATE_WORLD_STATES")

    local function bossexists()
	    for i = 1, MAX_BOSS_FRAMES do
		    if UnitExists("boss"..i) then
			    return true
		    end
	    end
    end

    vmboss:SetScript("OnEvent", function(self, event)
        local _, instanceType = IsInInstance()
        local bar = _G["WorldStateCaptureBar1"]
        
       -- 团本boss战自动关闭
	    if instanceType=="raid" and bossexists() then
		    if not vm.collapsed then
			    ObjectiveTracker_Collapse()
		    end

		-- PVP自动关闭
	    elseif instanceType=="arena" or instanceType=="pvp" then
            if not vm.collapsed then
			    ObjectiveTracker_Collapse()
		    end
		-- 获得追踪栏关闭
		elseif bar and bar:IsVisible() then
		    if not vm.collapsed then
			    ObjectiveTracker_Collapse()
		    end
		-- 团队副本且不在战斗状态打开
	    elseif vm.collapsed and instanceType=="raid" and not InCombatLockdown() then
		    ObjectiveTracker_Expand()
		
	    end

    end)
	
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)